%define major		%{version}
%define libname		%mklibname opal %{major}
%define develname	%mklibname %{name} -d

%define build_plf 0
%{?_with_plf: %{expand: %%global build_plf 1}}

%if "%distro_section" == "tainted"
%global build_plf 1
%endif

%define build_libavcodec 1

%define url_ver %(echo %{version} | cut -d. -f1,2)

Summary:	VoIP library
Name:		opal3
Version:	3.16.2
Release:	%mkrel 5
License:	MPL
Group:		System/Libraries
URL:		http://www.opalvoip.org/
Source0:	http://downloads.sourceforge.net/opalvoip/opal-%{version}.tar.bz2
Patch0:		opal-ffmpeg-4.0.patch
Patch1:		opal-linking.patch
Patch2:		opal-iLBC-2.0.patch
Patch3:		opal-aarch64.patch
Patch101:	0001-Added-support-for-system-based-SRTP-library-version-.patch
Patch102:	0001-Fixed-recent-SRTP-const-issue-change-for-different-p.patch

BuildRequires:	gawk
BuildRequires:	gsm-devel
BuildRequires:	pkgconfig(openssl)
BuildRequires:	openldap-devel
BuildRequires:	pkgconfig(ptlib) >= 2.16.2
BuildRequires:	pkgconfig(speex)
BuildRequires:	pkgconfig(speexdsp)
BuildRequires:	pkgconfig(theora)
BuildRequires:	pkgconfig(libilbc) >= 2.0.0
BuildRequires:	pkgconfig(libsrtp)
%if %{build_libavcodec}
BuildRequires:	ffmpeg-devel
%endif
%if %{build_plf}
BuildRequires:	x264-devel
%endif

%description
This is an open source class library for the development of
applications that wish to use SIP / H.323 protocols for multimedia
communications over packet based networks.

%if %{build_plf}
This package is in the Tainted section because the H264 codec is covered by
patents.
%endif

%package -n	%{libname}-plugins
Summary:	Codec plugins for Opal
Group:		System/Libraries
Provides:	%{name}-plugins = %{version}-%{release}

%description -n	%{libname}-plugins
PTlib codec plugins for various formats provided by Opal.

%package -n	%{libname}
Summary:	Opal Library
Group:		System/Libraries
Provides:	%{name} = %{version}-%{release}
Requires:	%{libname}-plugins = %{version}-%{release}

%description -n	%{libname}
Shared library for OPAL (SIP / H323 stack).

%package -n	%{develname}
Summary:	Opal development files
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Requires:	ptlib-devel >= 2.16.2
Provides:	%{name}-devel = %{version}-%{release}

%description -n	%{develname}
Header files and libraries for developing applications that use
Opal.

%prep
%setup -q -n opal-%{version}
%autopatch -p1

# fix build on aarch64
for d in $(find . -name "config.sub"); do
  cp -af %{_rpmconfigdir}/config.{guess,sub} $(dirname $d)
done

%build
export CFLAGS="%{optflags} -fPIC"
export CXXFLAGS="%{optflags} -fPIC"
%configure2_5x \
%if ! %{build_libavcodec}
	--disable-libavcodec \
%endif
%ifarch %ix86
	--disable-g.722.2 \
%endif
	--disable-static
%make_build V=1 STRIP=''

%install
%make_install

# remove incorrect symlinks (http://bugzilla.gnome.org/show_bug.cgi?id=553808 )
rm -f %{buildroot}%{_libdir}/libopal.so.?
rm -f %{buildroot}%{_libdir}/libopal.so.?.?

# we don't want these
find %{buildroot} -name "*.la" -o -name "*.a" -delete
rm -rf %{buildroot}%{_datadir}/opal/

%files -n %{libname}
%{_libdir}/lib*.so.%{major}{,.*}

%files -n %{libname}-plugins
%dir %{_libdir}/opal-%{version}/
%dir %{_libdir}/opal-%{version}/codecs/
%dir %{_libdir}/opal-%{version}/codecs/audio
%{_libdir}/opal-%{version}/codecs/audio/g7221_ptplugin.so
%ifnarch %ix86
%{_libdir}/opal-%{version}/codecs/audio/g7222_ptplugin.so
%endif
%{_libdir}/opal-%{version}/codecs/audio/g722_ptplugin.so
%{_libdir}/opal-%{version}/codecs/audio/g726_ptplugin.so
%{_libdir}/opal-%{version}/codecs/audio/gsm0610_ptplugin.so
%{_libdir}/opal-%{version}/codecs/audio/gsmamrcodec_ptplugin.so
%{_libdir}/opal-%{version}/codecs/audio/iLBC_ptplugin.so
%{_libdir}/opal-%{version}/codecs/audio/iSAC_ptplugin.so
%{_libdir}/opal-%{version}/codecs/audio/ima_adpcm_ptplugin.so
%{_libdir}/opal-%{version}/codecs/audio/lpc10_ptplugin.so
%{_libdir}/opal-%{version}/codecs/audio/opus_ptplugin.so
%{_libdir}/opal-%{version}/codecs/audio/silk_ptplugin.so
%{_libdir}/opal-%{version}/codecs/audio/speex_ptplugin.so
%dir %{_libdir}/opal-%{version}/codecs/video/
%{_libdir}/opal-%{version}/codecs/video/h261_vic_ptplugin.so
%{_libdir}/opal-%{version}/codecs/video/h263_ffmpeg_ptplugin.so
%if %{build_plf}
%{_libdir}/opal-%{version}/codecs/video/h264_video_pwplugin_helper
%{_libdir}/opal-%{version}/codecs/video/h264_x264_ptplugin.so
%endif
%{_libdir}/opal-%{version}/codecs/video/mpeg4_ffmpeg_ptplugin.so
%{_libdir}/opal-%{version}/codecs/video/theora_ptplugin.so
%{_libdir}/opal-%{version}/codecs/video/vp8_webm_ptplugin.so

%files -n %{develname}
%doc mpl-1.0.htm
%{_libdir}/*.so
%{_includedir}/*
%{_libdir}/pkgconfig/opal.pc


%changelog
* Sun Feb 10 2019 zezinho <zezinho> 3.16.2-5.mga7
+ Revision: 1365097
- rebuild for libvpx 1.8.0

* Sun Dec 30 2018 luigiwalser <luigiwalser> 3.16.2-4.mga7
+ Revision: 1347156
- rebuild for x264

* Sun Sep 23 2018 umeabot <umeabot> 3.16.2-3.mga7
+ Revision: 1299969
- Mageia 7 Mass Rebuild

* Sat Aug 04 2018 wally <wally> 3.16.2-2.mga7
+ Revision: 1247385
- disable G.722.2 plugin on ix86 for now as it fails to build
- new version 3.16.2
- enable libavcodec again

* Sun Jun 24 2018 daviddavid <daviddavid> 3.10.10-17.mga7.tainted
+ Revision: 1239341
- disable libavcodec (ffmpeg4 not yet compatible)
- rebuild for new x264

* Fri Oct 06 2017 daviddavid <daviddavid> 3.10.10-16.mga7
+ Revision: 1169542
- patch4: fix build with gcc7

* Tue May 02 2017 akien <akien> 3.10.10-15.mga6.tainted
+ Revision: 1098314
- Rebuild for ffmpeg 3.3

* Sat Mar 11 2017 cjw <cjw> 3.10.10-14.mga6
+ Revision: 1091956
- patch3: fix build with ffmpeg 3.2.x
+ akien <akien>
- Rebuild for ffmpeg 3.2.4

* Mon Jan 18 2016 luigiwalser <luigiwalser> 3.10.10-12.mga6
+ Revision: 925621
- rebuild for x264

* Tue Nov 10 2015 daviddavid <daviddavid> 3.10.10-11.mga6.tainted
+ Revision: 900882
- rebuild with new separate speexdsp package

* Tue Nov 10 2015 daviddavid <daviddavid> 3.10.10-10.mga6.tainted
+ Revision: 900786
- rebuild for new ptlib 2.10.11

* Fri Aug 28 2015 cjw <cjw> 3.10.10-9.mga6
+ Revision: 870540
- rebuild with gcc 5

* Sun Mar 30 2014 daviddavid <daviddavid> 3.10.10-8.mga5.tainted
+ Revision: 610546
- rebuild for new x264

* Mon Feb 17 2014 luigiwalser <luigiwalser> 3.10.10-7.mga5
+ Revision: 593274
- rebuild for x264

* Sat Aug 24 2013 luigiwalser <luigiwalser> 3.10.10-6.mga4.tainted
+ Revision: 471290
- more ffmpeg fixes

* Sat Aug 24 2013 luigiwalser <luigiwalser> 3.10.10-5.mga4
+ Revision: 470998
- rebuild for x264

* Mon Aug 05 2013 fwang <fwang> 3.10.10-4.mga4
+ Revision: 463752
- fix build with recent ffmpeg

* Mon Jun 17 2013 luigiwalser <luigiwalser> 3.10.10-3.mga4.tainted
+ Revision: 443891
- rebuild for x264

* Tue Mar 19 2013 luigiwalser <luigiwalser> 3.10.10-2.mga3
+ Revision: 404040
- fix conflicting version macro
- rebuild for updated ptlib

* Wed Feb 20 2013 ovitters <ovitters> 3.10.10-1.mga3
+ Revision: 399572
- new version 3.10.10

* Sun Jan 13 2013 umeabot <umeabot> 3.10.9-2.mga3.tainted
+ Revision: 361868
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Nov 27 2012 fwang <fwang> 3.10.9-1.mga3.tainted
+ Revision: 322284
- new version 3.10.9

* Sat Sep 15 2012 fwang <fwang> 3.10.7-2.mga3.tainted
+ Revision: 294226
- rebuild for new x264

* Mon Aug 27 2012 fwang <fwang> 3.10.7-1.mga3.tainted
+ Revision: 284551
- more ffmpeg patch

* Mon Aug 27 2012 fwang <fwang> 3.10.7-1.mga3
+ Revision: 284541
- more ffmpeg fixes
- fix build with latst ffmpeg
- rediff linkage patch
- new version 3.10.7

* Tue Aug 23 2011 fwang <fwang> 3.10.2-1.mga2
+ Revision: 134993
- rediff ffmpeg patch
- new version 3.10.2

* Wed Jul 20 2011 fwang <fwang> 3.10.1-1.mga2
+ Revision: 127507
- update file list
- update file list
- revert to type cast
- mofre ffmpeg 0.8 fix
- more ffmpeg 0.8 fix
- fix build with ffmpeg 0.8
- more build fix
- fix linkage
- new version 3.10.1

* Sun Jun 26 2011 fwang <fwang> 3.8.3-2.mga2.tainted
+ Revision: 114030
- rebuild for new x264

* Sat Jun 25 2011 ahmad <ahmad> 3.8.3-1.mga2.tainted
+ Revision: 113361
- Update to 3.8.3

* Sun Jun 19 2011 ahmad <ahmad> 3.6.8-4.mga2.tainted
+ Revision: 109571
- Replace PLF with Tainted in the package description (spotted by mikala)

* Thu Jun 16 2011 ahmad <ahmad> 3.6.8-3.mga2.tainted
+ Revision: 108336
- Drop X11-devel BR, doesn't seem needed any more
- Enable tainted build

* Fri Feb 25 2011 ennael <ennael> 3.6.8-2.mga1
+ Revision: 59449
- remove more
- clean spec file
- imported package opal3


* Mon Dec 06 2010 Götz Waschk <waschk@mandriva.org> 3.6.8-2mdv2011.0
+ Revision: 612286
- rebuild without celt, 0.9.1 is not supported

* Tue Jul 13 2010 Götz Waschk <waschk@mandriva.org> 3.6.8-1mdv2011.0
+ Revision: 552112
- fix build
- new version
- drop patch
- bump ptlib dep

* Wed May 05 2010 Götz Waschk <waschk@mandriva.org> 3.6.6-8mdv2010.1
+ Revision: 542339
- rebuild

* Fri Apr 09 2010 Ahmad Samir <ahmadsamir@mandriva.org> 3.6.6-7mdv2010.1
+ Revision: 533300
- rebuild for openssl-1.0.0

* Fri Feb 26 2010 Oden Eriksson <oeriksson@mandriva.com> 3.6.6-6mdv2010.1
+ Revision: 511600
- rebuilt against openssl-0.9.8m

* Wed Jan 27 2010 Götz Waschk <waschk@mandriva.org> 3.6.6-5mdv2010.1
+ Revision: 497058
- rebuild for new celt

* Sat Jan 23 2010 Götz Waschk <waschk@mandriva.org> 3.6.6-4mdv2010.1
+ Revision: 495216
- rebuild

* Thu Dec 10 2009 Götz Waschk <waschk@mandriva.org> 3.6.6-3mdv2010.1
+ Revision: 475965
- rebuild

* Mon Nov 09 2009 Götz Waschk <waschk@mandriva.org> 3.6.6-2mdv2010.1
+ Revision: 463550
- fix compilation with new celt

* Tue Sep 22 2009 Götz Waschk <waschk@mandriva.org> 3.6.6-1mdv2010.0
+ Revision: 447473
- new version

* Tue Jul 07 2009 Götz Waschk <waschk@mandriva.org> 3.6.4-1mdv2010.0
+ Revision: 393330
- new version
- drop patch

* Wed May 20 2009 Götz Waschk <waschk@mandriva.org> 3.6.2-2mdv2010.0
+ Revision: 377935
- fix for gcc 4.4

* Tue May 19 2009 Götz Waschk <waschk@mandriva.org> 3.6.2-1mdv2010.0
+ Revision: 377717
- update to new version 3.6.2

* Wed Mar 18 2009 Götz Waschk <waschk@mandriva.org> 3.6.1-3mdv2009.1
+ Revision: 357310
- really disable optmization

* Wed Mar 18 2009 Götz Waschk <waschk@mandriva.org> 3.6.1-2mdv2009.1
+ Revision: 357303
- disable optimization (bug #48476)

* Wed Mar 18 2009 Götz Waschk <waschk@mandriva.org> 3.6.1-1mdv2009.1
+ Revision: 357189
- new version
- bump ptlib dep

* Thu Mar 12 2009 Götz Waschk <waschk@mandriva.org> 3.6.0-3mdv2009.1
+ Revision: 354221
- disable stack align option again

* Sun Mar 08 2009 Götz Waschk <waschk@mandriva.org> 3.6.0-2mdv2009.1
+ Revision: 352997
- enable stack align hack for ffmpeg

* Tue Mar 03 2009 Götz Waschk <waschk@mandriva.org> 3.6.0-1mdv2009.1
+ Revision: 347632
- new version
- drop patch
- enable celt support
- bump ptlib dep

* Thu Jan 22 2009 Götz Waschk <waschk@mandriva.org> 3.5.2-3mdv2009.1
+ Revision: 332437
- fix h263 plugin with our ffmpeg

* Wed Jan 07 2009 Götz Waschk <waschk@mandriva.org> 3.5.2-2mdv2009.1
+ Revision: 326524
- add support for building with x264

* Tue Jan 06 2009 Götz Waschk <waschk@mandriva.org> 3.5.2-1mdv2009.1
+ Revision: 325479
- new version
- patch for new ffmpeg

* Tue Oct 21 2008 Götz Waschk <waschk@mandriva.org> 3.4.2-1mdv2009.1
+ Revision: 295971
- new version
- new major
- bump deps
- fix source URL

* Thu Sep 25 2008 Adam Williamson <awilliamson@mandriva.org> 3.4.1-2mdv2009.0
+ Revision: 288199
- don't package incorrect major / minor version symlinks
- obsolete incorrect major packages
- major should be 3.4.1, not 3 (per SONAME and upstream)

* Tue Sep 23 2008 Adam Williamson <awilliamson@mandriva.org> 3.4.1-1mdv2009.0
+ Revision: 287507
- adjust file list for yet another new codec layout
- use correct optflags
- drop both configure flags: one doesn't exist any more and the other was
  incorrect, we want to use system not local speex
- bump the ptlib-devel buildrequire (doesn't build with 2.3.1)
- drop pthread.patch (can't reliably maintain it while underlinking protection
  is disabled)
- disable underlinking protection (it now breaks all the ptlib checks)
- new release 3.4.1

* Tue Sep 02 2008 Adam Williamson <awilliamson@mandriva.org> 3.3.1-1mdv2009.0
+ Revision: 279341
- pkgconfig file's going to libdir now, not prefix/lib
- adjust file list
- update ptlib br
- add pthread.patch to 'fix' (see comment in spec) an underlinking issue
- new release 3.3.1 (from gnome.org)

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Tue May 13 2008 Adam Williamson <awilliamson@mandriva.org> 3.2.0-1mdv2009.0
+ Revision: 206814
- drop libname.patch (no longer needed)
- new release 3.2.0

* Sun Dec 30 2007 Adam Williamson <awilliamson@mandriva.org> 3.1.2-1mdv2008.1
+ Revision: 139479
- import opal3


